function _createForOfIteratorHelperLoose(r, e) { var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (t) return (t = t.call(r)).next.bind(t); if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e && r && "number" == typeof r.length) { t && (r = t); var o = 0; return function () { return o >= r.length ? { done: !0 } : { done: !1, value: r[o++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
import { CssClass } from '../constants';
export function createKeyboardController() {
  var menuList = new Map();
  var focusedIndex;
  var parentNode;
  var isRoot;
  var currentItems;
  var forceCloseSubmenu = false;
  function init(rootMenu) {
    currentItems = Array.from(rootMenu.values());
    focusedIndex = -1;
    isRoot = true;
  }
  function focusSelectedItem() {
    currentItems[focusedIndex].node.focus();
  }
  var isSubmenuFocused = function isSubmenuFocused() {
    return focusedIndex >= 0 && currentItems[focusedIndex].isSubmenu;
  };
  var getSubmenuItems = function getSubmenuItems() {
    return Array.from(currentItems[focusedIndex].submenuRefTracker.values());
  };
  function isFocused() {
    if (focusedIndex === -1) {
      // focus first item
      moveDown();
      return false;
    }
    return true;
  }
  function moveDown() {
    if (focusedIndex + 1 < currentItems.length) {
      focusedIndex++;
    } else if (focusedIndex + 1 === currentItems.length) {
      focusedIndex = 0;
    }
    if (forceCloseSubmenu) closeSubmenu();
    focusSelectedItem();
  }
  function moveUp() {
    if (focusedIndex === -1 || focusedIndex === 0) {
      focusedIndex = currentItems.length - 1;
    } else if (focusedIndex - 1 < currentItems.length) {
      focusedIndex--;
    }
    if (forceCloseSubmenu) closeSubmenu();
    focusSelectedItem();
  }
  function openSubmenu() {
    if (isFocused() && isSubmenuFocused()) {
      var submenuItems = getSubmenuItems();
      var _currentItems$focused = currentItems[focusedIndex],
        node = _currentItems$focused.node,
        setSubmenuPosition = _currentItems$focused.setSubmenuPosition;
      menuList.set(node, {
        isRoot: isRoot,
        focusedIndex: focusedIndex,
        parentNode: parentNode || node,
        items: currentItems
      });
      setSubmenuPosition();
      node.classList.add(CssClass.submenuOpen);
      parentNode = node;
      if (submenuItems.length > 0) {
        focusedIndex = 0;
        currentItems = submenuItems;
      } else {
        forceCloseSubmenu = true;
      }
      isRoot = false;
      focusSelectedItem();
      return true;
    }
    return false;
  }
  function closeSubmenu() {
    if (isFocused() && !isRoot) {
      var parent = menuList.get(parentNode);
      parentNode.classList.remove(CssClass.submenuOpen);
      currentItems = parent.items;
      parentNode = parent.parentNode;
      if (parent.isRoot) {
        isRoot = true;
        menuList.clear();
      }
      if (!forceCloseSubmenu) {
        focusedIndex = parent.focusedIndex;
        focusSelectedItem();
      }
    }
  }
  function matchKeys(e) {
    // matches shortcut inside submenu as well even when submenu is not open
    // it matches native menu behavior
    function walkAndMatch(items) {
      for (var _iterator = _createForOfIteratorHelperLoose(items), _step; !(_step = _iterator()).done;) {
        var item = _step.value;
        if (item.isSubmenu && item.submenuRefTracker) walkAndMatch(Array.from(item.submenuRefTracker.values()));
        item.keyMatcher && item.keyMatcher(e);
      }
    }
    walkAndMatch(currentItems);
  }
  return {
    init: init,
    moveDown: moveDown,
    moveUp: moveUp,
    openSubmenu: openSubmenu,
    closeSubmenu: closeSubmenu,
    matchKeys: matchKeys
  };
}