"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.createIcon = createIcon;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = require("react");
var _icons = require("@ant-design/icons");
var _isReact = require("./is-react");
var _isEsModule = require("./is-es-module");
var _svgIcon = require("./svg-icon");
var _lodash = require("lodash");
var LowcodeEngineIcon;
document.addEventListener('DOMContentLoaded', function () {
  // console.log('3 seconds passed');
  LowcodeEngineIcon = (0, _icons.createFromIconfontCN)({
    scriptUrl: '//at.alicdn.com/t/c/font_4742850_1i9u9jf4h66.js' // 在 iconfont.cn 上生成
  });
});
function isIconConfig(icon) {
  return (0, _lodash.isObject)(icon) && ('type' in icon || 'size' in icon || 'style' in icon);
}
var URL_RE = /^(https?:)\/\//i;
function createIcon(icon, props) {
  var _icon5, _icon7;
  if (!icon) {
    return null;
  }
  if ((0, _isEsModule.isESModule)(icon)) {
    icon = icon["default"];
  }
  var style = {
    fontSize: 16
  };
  if (props !== null && props !== void 0 && props.size) {
    var _icon;
    if (props !== null && props !== void 0 && props.size) {
      if (_svgIcon.SizePresets.hasOwnProperty(props === null || props === void 0 ? void 0 : props.size)) {
        style.fontSize = _svgIcon.SizePresets[props === null || props === void 0 ? void 0 : props.size];
      } else {
        style.fontSize = props === null || props === void 0 ? void 0 : props.size;
      }
    } else if (isIconConfig(icon) && (_icon = icon) !== null && _icon !== void 0 && _icon.size) {
      var _icon2;
      if (_svgIcon.SizePresets.hasOwnProperty((_icon2 = icon) === null || _icon2 === void 0 ? void 0 : _icon2.size)) {
        var _icon3;
        style.fontSize = _svgIcon.SizePresets[(_icon3 = icon) === null || _icon3 === void 0 ? void 0 : _icon3.size];
      } else {
        var _icon4;
        style.fontSize = (_icon4 = icon) === null || _icon4 === void 0 ? void 0 : _icon4.size;
      }
    }
  }
  if ((0, _lodash.isObject)(props) && (0, _lodash.isObject)(props === null || props === void 0 ? void 0 : props.style)) {
    style = (0, _extends2["default"])({}, props === null || props === void 0 ? void 0 : props.style, style);
  } else if (isIconConfig(icon) && (0, _lodash.isObject)((_icon5 = icon) === null || _icon5 === void 0 ? void 0 : _icon5.style)) {
    var _icon6;
    style = (0, _extends2["default"])({}, (_icon6 = icon) === null || _icon6 === void 0 ? void 0 : _icon6.style, style);
  }
  if (typeof icon === 'string') {
    if (URL_RE.test(icon)) {
      return /*#__PURE__*/(0, _react.createElement)('img', (0, _extends2["default"])({
        src: icon,
        className: props === null || props === void 0 ? void 0 : props.className
      }, props));
    }
    return /*#__PURE__*/React.createElement(LowcodeEngineIcon, (0, _extends2["default"])({
      type: 'icon-' + icon
    }, props, {
      style: style,
      size: ""
    }));
  }
  if (/*#__PURE__*/(0, _react.isValidElement)(icon)) {
    return /*#__PURE__*/(0, _react.cloneElement)(icon, (0, _extends2["default"])({}, props));
  }
  if ((0, _isReact.isReactComponent)(icon)) {
    return /*#__PURE__*/(0, _react.createElement)(icon, props);
  }
  return /*#__PURE__*/React.createElement(LowcodeEngineIcon, (0, _extends2["default"])({}, icon, {
    type: 'icon-' + ((_icon7 = icon) === null || _icon7 === void 0 ? void 0 : _icon7.type)
  }, props, {
    style: style
  }));
}