"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.REACT_MEMO_TYPE = exports.REACT_FORWARD_REF_TYPE = void 0;
exports.acceptsRef = acceptsRef;
exports.isForwardOrMemoForward = isForwardOrMemoForward;
exports.isForwardRefType = isForwardRefType;
exports.isMemoType = isMemoType;
exports.isReactClass = isReactClass;
exports.isReactComponent = isReactComponent;
exports.wrapReactClass = wrapReactClass;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = require("react");
var _cloneEnumerableProperty = require("./clone-enumerable-property");
var _excluded = ["children"];
var hasSymbol = typeof Symbol === 'function' && Symbol["for"];
var REACT_FORWARD_REF_TYPE = exports.REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol["for"]('react.forward_ref') : 0xead0;
var REACT_MEMO_TYPE = exports.REACT_MEMO_TYPE = hasSymbol ? Symbol["for"]('react.memo') : 0xead3;
function isReactClass(obj) {
  if (!obj) {
    return false;
  }
  if (obj.prototype && (obj.prototype.isReactComponent || obj.prototype instanceof _react.Component)) {
    return true;
  }
  return false;
}
function acceptsRef(obj) {
  var _obj$prototype;
  if (!obj) {
    return false;
  }
  if (obj !== null && obj !== void 0 && (_obj$prototype = obj.prototype) !== null && _obj$prototype !== void 0 && _obj$prototype.isReactComponent || isForwardOrMemoForward(obj)) {
    return true;
  }
  return false;
}
function isForwardRefType(obj) {
  if (!obj || !(obj !== null && obj !== void 0 && obj.$$typeof)) {
    return false;
  }
  return (obj === null || obj === void 0 ? void 0 : obj.$$typeof) === REACT_FORWARD_REF_TYPE;
}
function isMemoType(obj) {
  if (!obj || !(obj !== null && obj !== void 0 && obj.$$typeof)) {
    return false;
  }
  return obj.$$typeof === REACT_MEMO_TYPE;
}
function isForwardOrMemoForward(obj) {
  if (!obj || !(obj !== null && obj !== void 0 && obj.$$typeof)) {
    return false;
  }
  return (
    // React.forwardRef(..)
    isForwardRefType(obj) ||
    // React.memo(React.forwardRef(..))
    isMemoType(obj) && isForwardRefType(obj.type)
  );
}
function isReactComponent(obj) {
  if (!obj) {
    return false;
  }
  return Boolean(isReactClass(obj) || typeof obj === 'function' || isForwardRefType(obj) || isMemoType(obj));
}
function wrapReactClass(view) {
  var ViewComponentClass = /*#__PURE__*/function (_Component) {
    function ViewComponentClass() {
      return _Component.apply(this, arguments) || this;
    }
    (0, _inheritsLoose2["default"])(ViewComponentClass, _Component);
    var _proto = ViewComponentClass.prototype;
    _proto.render = function render() {
      var _this$props = this.props,
        children = _this$props.children,
        other = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, _excluded);
      return /*#__PURE__*/(0, _react.createElement)(view, other, children);
    };
    return ViewComponentClass;
  }(_react.Component);
  ViewComponentClass = (0, _cloneEnumerableProperty.cloneEnumerableProperty)(ViewComponentClass, view);
  ViewComponentClass.displayName = view.displayName;
  return ViewComponentClass;
}