"use strict";

exports.__esModule = true;
exports.contextMenu = void 0;
var _eventManager = require("./eventManager");
var _constants = require("../constants");
var contextMenu = exports.contextMenu = {
  show: function show(_ref) {
    var event = _ref.event,
      id = _ref.id,
      props = _ref.props,
      position = _ref.position,
      children = _ref.children;
    if (event.preventDefault) event.preventDefault();
    _eventManager.eventManager.emit(_constants.EVENT.HIDE_ALL).emit(id, {
      event: event.nativeEvent || event,
      props: props,
      position: position,
      children: children
    });
  },
  hideAll: function hideAll() {
    _eventManager.eventManager.emit(_constants.EVENT.HIDE_ALL);
  }
};